/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-agile-grasp-0.7.2-0quantal-20150517-0821/msg/Grasps.msg
 *
 */


#ifndef AGILE_GRASP_MESSAGE_GRASPS_H
#define AGILE_GRASP_MESSAGE_GRASPS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <agile_grasp/Grasp.h>

namespace agile_grasp
{
template <class ContainerAllocator>
struct Grasps_
{
  typedef Grasps_<ContainerAllocator> Type;

  Grasps_()
    : header()
    , grasps()  {
    }
  Grasps_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , grasps(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::vector< ::agile_grasp::Grasp_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::agile_grasp::Grasp_<ContainerAllocator> >::other >  _grasps_type;
  _grasps_type grasps;




  typedef boost::shared_ptr< ::agile_grasp::Grasps_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::agile_grasp::Grasps_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Grasps_

typedef ::agile_grasp::Grasps_<std::allocator<void> > Grasps;

typedef boost::shared_ptr< ::agile_grasp::Grasps > GraspsPtr;
typedef boost::shared_ptr< ::agile_grasp::Grasps const> GraspsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::agile_grasp::Grasps_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::agile_grasp::Grasps_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace agile_grasp

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'agile_grasp': ['/tmp/buildd/ros-hydro-agile-grasp-0.7.2-0quantal-20150517-0821/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::agile_grasp::Grasps_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::agile_grasp::Grasps_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::agile_grasp::Grasps_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::agile_grasp::Grasps_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::agile_grasp::Grasps_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::agile_grasp::Grasps_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::agile_grasp::Grasps_<ContainerAllocator> >
{
  static const char* value()
  {
    return "3b718d1a7961f2593896b8cec7c8808e";
  }

  static const char* value(const ::agile_grasp::Grasps_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x3b718d1a7961f259ULL;
  static const uint64_t static_value2 = 0x3896b8cec7c8808eULL;
};

template<class ContainerAllocator>
struct DataType< ::agile_grasp::Grasps_<ContainerAllocator> >
{
  static const char* value()
  {
    return "agile_grasp/Grasps";
  }

  static const char* value(const ::agile_grasp::Grasps_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::agile_grasp::Grasps_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
agile_grasp/Grasp[] grasps\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: agile_grasp/Grasp\n\
geometry_msgs/Vector3 center\n\
geometry_msgs/Vector3 axis\n\
geometry_msgs/Vector3 approach\n\
geometry_msgs/Vector3 surface_center\n\
std_msgs/Float32 width\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: std_msgs/Float32\n\
float32 data\n\
";
  }

  static const char* value(const ::agile_grasp::Grasps_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::agile_grasp::Grasps_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.grasps);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Grasps_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::agile_grasp::Grasps_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::agile_grasp::Grasps_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "grasps[]" << std::endl;
    for (size_t i = 0; i < v.grasps.size(); ++i)
    {
      s << indent << "  grasps[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::agile_grasp::Grasp_<ContainerAllocator> >::stream(s, indent + "    ", v.grasps[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // AGILE_GRASP_MESSAGE_GRASPS_H
